wyh的迷宫

涉及知识点:求迷宫能否到达终点的,而不是求路径数的,用bfs时可以不用重置状态数组(回溯)。

题目描述

给你一个n*m的迷宫,这个迷宫中有以下几个标识:

s代表起点

t代表终点

x代表障碍物

.代表空地

现在你们涵哥想知道能不能从起点走到终点不碰到障碍物(只能上下左右进行移动,并且不能移动到已经移动过的点)。

输入描述:

复制代码
输入第一行一个整数T(1<=T<=10)
接下来有T组测试数据,对于每一组测试数据,第一行输入2个数n和m(1<=n,m<=500)
接下来n行,每行m个字符代表这个迷宫,每个字符都是上面4个中的一种
数据保证只有一个起点和一个终点

输出描述:

复制代码
对于每一组测试数据,如果可以的话输出YES,不可以的话输出NO

示例1

输入

复制1 3 5 s...x x...x ...tx

复制代码
1
3 5
s...x
x...x
...tx

输出

复制YES

复制代码
YES

想法:

用dfs求,结果超时了。毕竟都500层了......

代码:

#include<bits/stdc++.h>

using namespace std;

int n,m;

int ans;

char mg510510;

int a,b;//终点

int dx\[\]={0,0,1,-1};

int dy\[\]={1,-1,0,0};

int st510510;

void dfs(int x,int y){

for(int i=0;i<4;i++){

int xx=dxi+x;

int yy=dyi+y;

if(xx<1||yy<1||xx>n||yy>m) continue;

if(mgxxyy=='x') continue;

if(stxxyy) continue;

if(xx==a&&yy==b) {ans++; return;}

stxxyy=1;

dfs(xx,yy);

stxxyy=0;

}

}

int main(){

int t;

cin>>t;

while(t--){

memset(st,0,sizeof(st));

ans=0;

cin>>n>>m;

int x,y;

for(int i=1;i<=n;i++){

for(int j=1;j<=m;j++){

cin>>mgij;

if(mgij=='s') { x=i,y=j;}

if(mgij=='t') { a=i,b=j;}

}

}

dfs(x,y);

if(ans) cout<<"YES"<<endl;

else cout<<"NO"<<endl;

}

return 0 ;

}

想法:

今天看网课,讲到bfs的时间复杂度要比dfs小(其实是回溯了的dfs时间复杂度才比bfs大很多),所以就试试bfs的写法,过了。还学到了一个小技巧,队列中的坐标的存储可以不用数对pair,用一个数值表示。

代码:

#include<bits/stdc++.h>

using namespace std;

int n,m;

int ans;

char mg510510;

int dx\[\]={0,0,1,-1};

int dy\[\]={1,-1,0,0};

int st510510;

queue <int> q;

void bfs(int x,int y){

q.push(x*m+y);

while(!q.empty()){

int a=q.front()/m;

int b=q.front()%m;

q.pop();

for(int i=0;i<4;i++){

int xx=a+dxi;

int yy=b+dyi;

if(mgxxyy=='x') continue;

if(mgxxyy=='t') { ans=1;break;}//到终点

if(stxxyy) continue;

if(xx>=n||xx<0||yy<0||yy>=m) continue;

stxxyy=1;

q.push(xx*m+yy);

}

if(ans==1) return ;

}

}

int main(){

int t;

cin>>t;

while(t--){

memset(st,0,sizeof(st));

ans=0;

cin>>n>>m;

int x,y;

for(int i=0;i<n;i++){

for(int j=0;j<m;j++){

cin>>mgij;

if(mgij=='s') { x=i,y=j;}

}

}

stxy=1;

bfs(x,y);

if(ans) cout<<"YES"<<endl;

else cout<<"NO"<<endl;

}

return 0 ;

}

事情到这并没有结束,我写完就去翻了一下别人的题解,发现其实也可以用dfs写出来,我们不需要具体路径,只需要知道起点终点是否连通(我本来想用连通块写的,但感觉还是会超时,就否决了),因此,本题不用回溯也不可以回溯,回溯会超时。这么做时间复杂度和上一个bfs的时一样的,就是全部格子都搜了一遍,时间复杂度为O(n*m)。

代码:

#include<bits/stdc++.h>

using namespace std;

int n,m;

int ans;

char mg510510;

int a,b;//终点

int dx\[\]={0,0,1,-1};

int dy\[\]={1,-1,0,0};

int st510510;

void dfs(int x,int y){

for(int i=0;i<4;i++){

int xx=dxi+x;

int yy=dyi+y;

if(xx<1||yy<1||xx>n||yy>m) continue;

if(mgxxyy=='x') continue;

if(stxxyy) continue;

if(xx==a&&yy==b) {ans++; return;}

stxxyy=1;

dfs(xx,yy);

//stxxyy=0;

}

}

int main(){

int t;

cin>>t;

while(t--){

memset(st,0,sizeof(st));

ans=0;

cin>>n>>m;

int x,y;

for(int i=1;i<=n;i++){

for(int j=1;j<=m;j++){

cin>>mgij;

if(mgij=='s') { x=i,y=j;}

if(mgij=='t') { a=i,b=j;}

}

}

dfs(x,y);

if(ans) cout<<"YES"<<endl;

else cout<<"NO"<<endl;

}

return 0 ;

}

嗐,其实还是感觉怪怪的,再想想吧。

相关推荐
zyl7659 小时前
FlashAttention 详解:从 GPU 硬件、普通 Attention 到分块计算与 Online Softmax
算法
爱读书的小胖13 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌13 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F13 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_3077791313 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
tomwang032214 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!14 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
2501_9269783314 小时前
人机通信协议--人和机器之间的交互想象
人工智能·经验分享·算法·ai写作
行者全栈架构师14 小时前
【鸿蒙心迹】互动卡片全链路——把核心功能放到桌面(FormKit 实战)(HarmonyOS 7.x)
前端·算法·架构
无定义_14 小时前
10.11日常训练
算法